
    HDOS Partition structure format (at initialisation)

                           Offsets        Size in Blocks
     +------------+  <---- z = 0
     |   BOOT     |
     |            |<====================  1
     |  Block     |
     +------------+  <---- y = 1
     |   ALV      |
     |            |<====================  a = 16/P_PBlkSz
     |  Blocks    |
     +------------+  <---- x = y + a
     | Directory  |
     |            |<====================  b = P_NumDirs
     |  Blocks    |
     +------------+  <---- w = x + b
     | File Data  |
     |            |<====================  c = P_NumLBA - w
     |  Blocks    |
     +------------+  <---- v = P_NumLBA

Note  16 = Max_Blocks_16Bit/Max_Indicies_Per_Sector
         = 65536 / 4096

  V_PAlvSt = y
  V_PAlvSz = a
  V_PDirSt = x
  V_PDirSz = P_NumDirs
  V_PDatSt = w
  V_PDatSz = c

=====================================================================


    FAT32 Partition structure format (at initialisation)

                           Offsets        Size in Blocks
     +------------+- <---- z = 0
     | Boot and   | \
     | Volume ID  |  >==================  1
     |   Block    | /
     +------------+- <---- y = 1
     |   FAT      | \
     |   Data     |  >==================  a =  (P_NumLBA-n)
     |  Blocks    | /                         -------------- x NumFATs
     +------------+- <---- w = y + a          (P_PBlkSz*128)
     |  File and  | \
     | Directory  |  >==================  c = P_NumLBA - w
     |   Blocks   | /
     +------------+- <---- v = P_NumLBA


  V_PAlvSt = y
  V_PAlvSz = a
  V_PDirSt = w
  V_PDirSz = 1 (first block in file data)
  V_PDatSt = w
  V_PDatSz = c

Note n = original number of blocks in FAT which equals
         P_NumLBA/(P_PBlkSz*128)
         i.e is the number of blocks if FAT were to hold all
             blocks in the table.

-------------------------------------------------------------------------------------

FAT calculations in C code (all in integer math, fixed sector of 512 bytes)

/* Calculate the number of root dir sectors */
RootDirSectors = ((NumDirEntries * 32) + (512  1)) / 512;

TmpVal1 = DskSize  (NumReservedSectors + RootDirSectors);

TmpVal2 = (256 * BPB_SecPerClus) + BPB_NumFATs;

If(FATType == FAT32)
    TmpVal2 = TmpVal2 / 2;

FATSz = (TMPVal1 + (TmpVal2  1)) / TmpVal2;

If(FATType == FAT32)
 {
    BPB_FATSz16 = 0;
    BPB_FATSz32 = FATSz;
 }
else
 {
    BPB_FATSz16 = LOWORD(FATSz);
    /* there is no BPB_FATSz32 in a FAT16 BPB */
 }
-------------------------------------------------------------------------------------

FAT calculations in psuedo-code (using HDOS blocks)


NumRootDirSectors = P_BlockSz


/* Calc Number of sectors excluding reserved block */
NumSectorsforFATandData = (P_NumLBA - 1 ) x P_BlockSz


/*  Calc number of FAT16 indices per sector */
IndicesPerSector = 256 * P_BlockSz


If(FATType == FAT32)
    TmpVal2 = TmpVal2 / 2;  /* re-calc number of FAT32 indices per sector */


/* calc number of FAT sectors */
FATSz = ROUNDUP(NumSectorsforFATandData / IndicesPerSector);
NumFATblocks = ROUNDUP(FATSz / P_BlockSz)



Note: ROUNDUP will increment the integer result if the remainder <> 0.